import * as setting from "./setting";
import * as creepApi from "./creepApi"

const createDefaultHarvester = (spawn: StructureSpawn) => {
    return creepApi.SpawnCreep(spawn, setting.mk1Body, setting.Role.Harvester);
}
const createDefaultBuilder = (spawn: StructureSpawn) => {
    return creepApi.SpawnCreep(spawn, setting.mk1Body, setting.Role.Builder);
};

const createDefaultUpgrader = (spawn: StructureSpawn) => {
    return creepApi.SpawnCreep(spawn, setting.mk1Body, setting.Role.Upgrader);
};

const createMk2Harvester = (spawn: StructureSpawn) => {
    return creepApi.SpawnCreep(spawn, setting.Mk2harvesterBody, setting.Role.BigHarvester);
}

export function SpawnCreep(spawn: StructureSpawn) {
    if (spawn.spawning) return;

    let currentCreeps = creepApi.GetCreeps();
    if (currentCreeps.get(creepApi.RoleToString(setting.Role.Harvester)) > setting.HARVESTER_COUNT) {
        if (createDefaultHarvester(spawn) == 0) {
            console.log("Spawn Harvester")
        }
    }
    if (currentCreeps.get(creepApi.RoleToString(setting.Role.Upgrader)) > setting.UPGRADER_COUNT) {
        if (createDefaultUpgrader(spawn) == 0) {
            console.log("Spawn Upgrader")
        }
    }
    if (currentCreeps.get(creepApi.RoleToString(setting.Role.Builder)) > setting.BUILDER_COUNT) {
        if (createDefaultBuilder(spawn) == 0) {
            console.log("Spawn Builder")
        }
    }
    if (spawn.spawning) {
        var spawningCreep = Game.creeps[spawn.spawning.name];
        spawn.room.visual.text(
            '🛠️' + spawningCreep.memory.role,
            spawn.pos.x + 1,
            spawn.pos.y,
            { align: 'left', opacity: 0.8 });
    }
}